program DelLine;

uses
    Dos;

label
     Ren_Ok;

var
   loFileName, bakFileName : PathStr;
   CON, loFile, bakFile : text;
   loFileD : DirStr;
   loFileN : NameStr;
   loFileE : ExtStr;
   i, line : longint;
{$IFDEF OS2}
   j : longint;
{$ELSE}
   j : integer;
{$ENDIF}
   TmpStr : string;
   bakDel : boolean;

function UpCaseStr(str : string) : string;
var
   i : byte;
   s : string;
begin
     s := '';
     for i := 1 to Length(str)
         do s := s + UpCase(str[i]);
     UpCaseStr := s;
end;


begin                      { + + + + + Main + + + + + }
     Assign(CON, 'CON');
     ReWrite(CON);
     WriteLn(CON);
     If (ParamStr(2) = '')
        then begin
                  WriteLn(CON, 'Usage: ' + ParamStr(0) +
                          ' [Line# TextFileName [/E]]' );
                  WriteLn(CON);
                  WriteLn(CON, 'This program removes line specified by number from text file.');
                  WriteLn(CON);
                  WriteLn(CON, 'Specifying /E parameter means no backup source file.');
                  WriteLn(CON);
                  WriteLn(CON, '(c) CopyLeft Vurdalak, 2:463/323@fidonet.org (Year#2000)');
                  WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 1');
                  Halt(1);
             end;
     loFileName := ParamStr(2);
     if ParamCount >= 3
        then begin
                  TmpStr := ParamStr(3);
                  bakDel := UpCase(TmpStr[2]) = 'E'
             end;
     Assign(loFile, loFileName);
{$I-}ReSet(loFile);{$I+}
     if IOResult <> 0
        then begin
                  WriteLn(CON, 'Error opening file ', loFileName);
                  WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 255');
                  Halt(255);
             end
        else begin
                  Close(loFile);
                  FSplit(loFileName, loFileD, loFileN, loFileE);
                  if UpCaseStr(loFileE) = '.BAK'
                     then bakFileName := loFileD + loFileN + '.$$$'
                     else bakFileName := loFileD + loFileN + '.BAK';
                  Assign(bakFile, bakFileName);
              {$I-}ReWrite(bakFile);{$I+}
                  i := Ord('0') - 1;
                  if IOResult <> 0
                     then while (IOResult <> 0) and
                                (i <= Ord('9'))
                                do begin
                                        i := i + 1;
                                        bakFileName := loFileD + loFileN +
                                                       '.BA' + Chr(i);
                                        Assign(bakFile, bakFileName);
                                   {$I-}ReWrite(bakFile);{$I+}
                                   end;
                  if IOResult = 0
                     then GoTo Ren_Ok;
                  i := Ord('A') - 1;
                  if IOResult <> 0
                     then while (IOResult <> 0) and
                                (i <= Ord('Z'))
                                do begin
                                        i := i + 1;
                                        bakFileName := loFileD + loFileN +
                                                       '.BA' + Chr(i);
                                        Assign(bakFile, bakFileName);
                                   {$I-}ReWrite(bakFile);{$I+}
                                   end;
                  if IOResult <> 0
                     then begin
                               WriteLn(CON, 'Can''t rename (backup) source file ', loFileName);
                               WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 254');
                               Halt(254);
                          end;
          Ren_Ok: Close(bakFile);
                  Erase(bakFile);
                  Assign(bakFile, loFileName);
                  ReName(bakFile, bakFileName);
                  if not bakDel
                     then WriteLn(CON, 'Source file ',loFileName,
                                       ' was renamed to ', bakFileName);
                  Assign(loFile, loFileName);
                  ReWrite(loFile);
                  ReSet(bakFile);
                  line := 0;
                  while not EOF(bakFile)
                        do begin
                                Inc(line);
                                Val(ParamStr(1), i, j);
                                ReadLn(bakFile, TmpStr);
                                if line <> i
                                   then WriteLn(loFile, TmpStr);
                           end;
                  TmpStr := ParamStr(3);
                  if bakDel
                     then Erase(bakFile);
                 WriteLn(CON, #$0D + #$0A + 'Exiting errorlevel 0');
                 Halt(0);
             end;
end.